﻿Imports Microsoft.Practices.Composite.Wpf.Regions
Imports Microsoft.Practices.Composite.Regions
Imports Infragistics.Windows.Controls
Imports System.Collections.Specialized
Imports System.ComponentModel
Imports Infragistics.Windows.DockManager

Namespace RegionAdapters

    Public Class TabGroupPaneRegionAdapter
        Inherits RegionAdapterBase(Of TabGroupPane)

        Private m_regionTarget As TabGroupPane

        Protected Overrides Sub Adapt(ByVal region As Microsoft.Practices.Composite.Regions.IRegion, ByVal regionTarget As TabGroupPane)
            m_regionTarget = regionTarget

            'If control has child items, move them to the region and then bind control to region. Can't set ItemsSource if child items exist.
            If regionTarget.Items.Count > 0 Then
                For Each childItem In regionTarget.Items
                    Dim rName As String = childItem.GetValue(RegionManager.RegionNameProperty)
                    If Not String.IsNullOrEmpty(rName) Then
                        region.RegionManager.AttachNewRegion(childItem, rName)
                    End If
                    region.Add(childItem)
                Next
            End If

            regionTarget.Items.Clear()

            AddHandler region.ActiveViews.CollectionChanged, AddressOf OnActiveViewsChanged
            For Each v In region.ActiveViews
                regionTarget.Items.Add(v)
            Next

        End Sub

        Private Sub OnActiveViewsChanged(ByVal sender As Object, ByVal e As NotifyCollectionChangedEventArgs)
            Select Case e.Action
                Case NotifyCollectionChangedAction.Add
                    For Each v In e.NewItems
                        m_regionTarget.Items.Add(v)
                    Next
                Case NotifyCollectionChangedAction.Remove
                    For Each v In e.OldItems
                        m_regionTarget.Items.Remove(v)
                    Next
            End Select
        End Sub

        Protected Overrides Function CreateRegion() As Microsoft.Practices.Composite.Regions.IRegion
            Return New AllActiveRegion
        End Function

    End Class

End Namespace