//===============================================================================
// Microsoft patterns & practices
// Composite Application Guidance for Windows Presentation Foundation
//===============================================================================
// Copyright (c) Microsoft Corporation.  All rights reserved.
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY
// OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT
// LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
// FITNESS FOR A PARTICULAR PURPOSE.
//===============================================================================
// The example companies, organizations, products, domain names,
// e-mail addresses, logos, people, places, and events depicted
// herein are fictitious.  No association with any real company,
// organization, product, domain name, email address, logo, person,
// places, or events is intended or should be inferred.
//===============================================================================

using Microsoft.Practices.Composite.Regions;

namespace Microsoft.Practices.Composite.Wpf.Tests.Mocks
{
    internal class MockRegionAdapter : IRegionAdapter
    {
        public MockRegion region = new MockRegion();
        public bool InitializeCalled;
        public object InitializeArgument;
        #region IRegionAdapter Members

        public IRegion Initialize(object regionTarget)
        {
            InitializeCalled = true;
            InitializeArgument = regionTarget;
            return region;
        }

        #endregion
    }
}