﻿Imports System.Globalization
Imports Microsoft.TeamFoundation.Client
Imports Microsoft.TeamFoundation.WorkItemTracking.Client


Partial Public Class Welcome

    Public Window As MainWindow

    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        
    End Sub

#Region " routed events "



    Public Custom Event ServerButtonClick As RoutedEventHandler

        AddHandler(ByVal value As RoutedEventHandler)
            Me.AddHandler(ServerButtonClickEvent, value)
        End AddHandler

        RemoveHandler(ByVal value As RoutedEventHandler)
            Me.RemoveHandler(ServerButtonClickEvent, value)
        End RemoveHandler

        RaiseEvent(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs)
            Me.RaiseEvent(e)
        End RaiseEvent
    End Event

    Public Shared ReadOnly ServerButtonClickEvent As RoutedEvent = _
                      EventManager.RegisterRoutedEvent("ServerButtonClick", _
                      RoutingStrategy.Bubble, _
                      GetType(RoutedEventHandler), GetType(Welcome))



#End Region

    Public Sub Refresh()
        DisplayVersion()
        DisplayServers()
    End Sub

    ''' <summary>
    ''' Display the application version.
    ''' </summary>
    Private Sub DisplayVersion()
        Dim Version As Version = System.Reflection.Assembly.GetExecutingAssembly().GetName().Version
        VersionLabel.Content = String.Format(CultureInfo.CurrentCulture, "Version {0}.{1}.{2}", Version.Major, Version.Minor, Version.Build)
        ReleaseLabel.Content = String.Format(CultureInfo.CurrentCulture, "Release {0}", Application.CodeplexReleaseId)
    End Sub

    ''' <summary>
    ''' Display a list of team Servers.
    ''' </summary>
    Private Sub DisplayServers()
        ServersStackPanel.Children.Clear()
        Try
            For Each svrnme As String In RegisteredServers.GetServerNames
                Dim svr As New TeamFoundationServer(svrnme, Me.Window.CredentialProviderBox)
                Dim serverButton As Button = New Button()
                serverButton.Content = svr.Name
                serverButton.Command = MainWindow.ChangeTeamServerCommand
                serverButton.CommandParameter = svr
                serverButton.Style = CType(FindResource("WelcomeButtonStyle"), Style)
                'AddHandler serverButton.Click, AddressOf ServerButton_Click
                ServersStackPanel.Children.Add(serverButton)
            Next
        Catch ex As Exception
            Dim serverButton As Button = New Button
            serverButton.Content = "Click here to install VSTS 2008 Team Explorer"
            serverButton.Command = MainWindow.ChangeTeamServerCommand
            serverButton.Style = CType(FindResource("WelcomeButtonStyle"), Style)
            AddHandler serverButton.Click, AddressOf ServerButton_Click
            ServersStackPanel.Children.Add(serverButton)
        End Try
    End Sub

    Private Sub ServerButton_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        System.Diagnostics.Process.Start("http://www.microsoft.com/downloads/details.aspx?familyid=0ED12659-3D41-4420-BBB0-A46E51BFCA86&displaylang=en")
        'Dim serverButton As Button = sender
        'MessageBox.Text = ""
        'Dim tfs As TeamFoundationServer = serverButton.CommandParameter
        'If tfs.HasAuthenticated Then
        '    [RaiseEvent](New RoutedEventArgs(ServerButtonClickEvent, sender))
        'Else
        '    Try
        '        tfs.Authenticate()
        '        [RaiseEvent](New RoutedEventArgs(ServerButtonClickEvent, sender))
        '    Catch ex As Exception
        '        MessageBox.Text = ex.Message
        '    End Try
        'End If
    End Sub


 
End Class
