﻿Imports Microsoft.TeamFoundation.WorkItemTracking.Client

Public Class StickyItemControl

    Private m_Project As Project

    Public ReadOnly Property Project() As Project
        Get
            Return m_Project
        End Get
    End Property

    Private m_Node As Node

    Public ReadOnly Property Node() As Node
        Get
            Return m_Node
        End Get
    End Property

    Private m_WorkItem As WorkItem

    Public ReadOnly Property WorkItem() As WorkItem
        Get
            Return m_WorkItem
        End Get
    End Property

    Public Sub SetValues(ByVal Project As Project, ByVal Node As Node, ByVal WorkItem As WorkItem)
        m_Project = Project
        m_Node = Node
        m_WorkItem = WorkItem
        Refresh()
    End Sub

    Public Shadows Sub Refresh()

        Me.ux_GroupBox.Text = String.Format("{0}: {1}", WorkItem.Id.ToString, WorkItem.Type.Name.ToString)
        Me.ux_FlowLayoutPanel.Controls.Clear()
        Me.ux_FlowLayoutPanel.Controls.Add(Getlabel(WorkItem.Title.ToString))
        Me.ux_FlowLayoutPanel.Controls.Add(Getlabel(WorkItem.Item("System.AssignedTo").ToString))
        Me.ux_FlowLayoutPanel.Controls.Add(Getlabel(WorkItem.State.ToString))
        Me.ux_WorkItemSummeryControl.SetValues(Project, Node, WorkItem)
        '-------------
        MyBase.Refresh()
    End Sub

    Private Function Getlabel(ByVal ValueToDisplay As String) As Label
        Dim ux_lbl As New Label
        ux_lbl.Text = ValueToDisplay
        ux_lbl.AutoSize = True
        Return ux_lbl
    End Function


End Class
